// Copyright (c) 1996-2002 Brian D. Carlstrom

package bdc.scheme.expression;

import bdc.scheme.SchemeException;
import bdc.scheme.Stack;
import bdc.scheme.exception.ArgumentCountException;

abstract public class Procedure3 extends Procedure
{
    public Object apply0 (Stack stack) throws SchemeException
    {
        throw new ArgumentCountException(this, 3, 0);
    }

    public Object apply1 (Stack stack) throws SchemeException
    {
        throw new ArgumentCountException(this, 3, 1);
    }

    public Object apply2 (Stack stack) throws SchemeException
    {
        throw new ArgumentCountException(this, 3, 2);
    }

    abstract public Object apply3 (Stack stack) throws SchemeException;

    public Object apply4 (Stack stack) throws SchemeException
    {
        throw new ArgumentCountException(this, 3, 4);
    }

    public Object applyN (int n, Stack stack) throws SchemeException
    {
        throw new ArgumentCountException(this, 3, n);
    }
}
