// Copyright (c) 1996-2002 Brian D. Carlstrom

package bdc.scheme.procedure;

import bdc.scheme.Scheme;
import bdc.scheme.SchemeException;
import bdc.scheme.Stack;
import bdc.scheme.exception.SchemeError;
import bdc.scheme.expression.Procedure1;

/**
    (error x)
*/
public class Error extends Procedure1
{
    public Object apply1 (Stack stack) throws SchemeException
    {
        Object o1 = stack.array[stack.inUse-1];
        throw new SchemeError(Scheme.string(o1, this));
    }
}
