// Copyright (c) 1996-2002 Brian D. Carlstrom

package bdc.scheme.procedure;

import bdc.scheme.Scheme;
import bdc.scheme.SchemeException;
import bdc.scheme.Stack;
import bdc.scheme.expression.Procedure1;
import java.io.PushbackReader;

/**
    (set-current-input-port port)
*/
public class SetCurrentInputPort extends Procedure1
{
    public Object apply1 (Stack stack) throws SchemeException
    {
        Object o1 = stack.array[stack.inUse-1];

        PushbackReader port = Scheme.pushbackReader(o1, this);
        stack.currentInputPort = port;
        return Scheme.Unspecified;
    }
}
