// Copyright (c) 1996-2002 Brian D. Carlstrom

package bdc.scheme.exception;

import bdc.scheme.SchemeException;
import bdc.scheme.Symbol;
import bdc.util.Fmt;

public class UnassignedVarException extends SchemeException
{
    public Symbol name;

    public UnassignedVarException (Symbol name)
    {
        this.name = name;
    }

    public String toString ()
    {
        return Fmt.S("Unassigned variable: %s", name);
    }
}
