// Copyright (c) 1996-2002 Brian D. Carlstrom

package bdc.scheme.procedure;

import bdc.scheme.Stack;
import bdc.scheme.Scheme;
import bdc.scheme.exception.ArgumentTypeException;
import bdc.scheme.expression.Procedure2;

/**
    (char=&34; x y)
*/
public class CharEqual extends Procedure2
{
    public Object apply2 (Stack stack) throws ArgumentTypeException
    {
        Object o1 = stack.array[stack.inUse-1];
        Object o2 = stack.array[stack.inUse-2];
        if (Scheme.character(o1, this) == Scheme.character(o2, this)) {
            return Boolean.TRUE;
        }
        return Boolean.FALSE;
    }
}
