// Copyright (c) 1996-2002 Brian D. Carlstrom

package bdc.scheme.procedure;

import bdc.scheme.Stack;
import bdc.scheme.expression.Procedure2;

/**
    (eq&34; x y)
*/
public class Eq extends Procedure2
{
    public Object apply2 (Stack stack)
    {
        Object o1 = stack.array[stack.inUse-1];
        Object o2 = stack.array[stack.inUse-2];
        if (o1 == o2) {
            return Boolean.TRUE;
        }
        return Boolean.FALSE;
    }
}
