// Copyright (c) 1996-2002 Brian D. Carlstrom

package bdc.scheme.procedure;

import bdc.scheme.Stack;
import bdc.scheme.expression.Procedure2;
import bdc.scheme.Scheme;
import bdc.scheme.SchemeException;

/**
    Primitive for List.add
*/
public class ListAdd extends Procedure2
{
    public Object apply2 (Stack stack) throws SchemeException
    {
        Object o1 = stack.array[stack.inUse-1];
        Object o2 = stack.array[stack.inUse-2];
        Scheme.list(o1, this).add(o2);
        return Scheme.Unspecified;
    }
}
